#ifndef __PRINT_HELPERS_HPP
#define __PRINT_HELPERS_HPP

#include <iomanip>
#include <ostream>

extern "C" {
#include "fp12e.h"
#include "fp6e.h"
#include "fp2e.h"
#include "fpe.h"
}

class Fp12e {
    public:
        Fp12e(const fp12e_t& input);
        friend std::ostream& operator<<(std::ostream& os, const Fp12e& output);

    private:
        fp12e_t data;
};

class Fp6e {
    public:
        Fp6e(const fp6e_t& input);
        friend std::ostream& operator<<(std::ostream& os, const Fp6e& output);

    private:
        fp6e_t data;
};

class Fp2e {
    public:
        Fp2e(const fp2e_t& input);
        friend std::ostream& operator<<(std::ostream& os, const Fp2e& output);

    private:
        fp2e_t data;
};

class Fpe {
    public:
        Fpe(const fpe_t& input);
        friend std::ostream& operator<<(std::ostream& os, const Fpe& output);

    private:
        fpe_t data;
};

#endif
